"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateTraceProxyOutput = exports.validateTraceProxyInput = exports.validateOptionsProxyOutput = exports.validateOptionsProxyInput = exports.validateHeadProxyOutput = exports.validateHeadProxyInput = exports.validateDeleteProxyOutput = exports.validateDeleteProxyInput = exports.validatePatchProxyOutput = exports.validatePatchProxyInput = exports.validatePutProxyOutput = exports.validatePutProxyInput = exports.validatePostProxyOutput = exports.validatePostProxyInput = exports.validateGetProxyOutput = exports.validateGetProxyInput = exports.validateDeleteInstitutionsByInstitutionIdOutput = exports.validateDeleteInstitutionsByInstitutionIdInput = exports.validatePatchInstitutionsByInstitutionIdOutput = exports.validatePatchInstitutionsByInstitutionIdInput = exports.validateGetInstitutionsByInstitutionIdOutput = exports.validateGetInstitutionsByInstitutionIdInput = exports.validatePostInstitutionsOutput = exports.validatePostInstitutionsInput = exports.validateGetInstitutionsOutput = exports.validateGetInstitutionsInput = void 0;
const basicValidation_1 = require("./basicValidation");
/**
 * This function validates the inputs of a GET request on /institutions
 */
function validateGetInstitutionsInput() {
    return true;
}
exports.validateGetInstitutionsInput = validateGetInstitutionsInput;
/**
 * This function validates the outputs to a GET request on /institutions
 */
function validateGetInstitutionsOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetInstitutionsResponse200)(response.body)) {
            validateGetInstitutionsOutput.errors = basicValidation_1.validateGetInstitutionsResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetInstitutionsOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetInstitutionsOutput = validateGetInstitutionsOutput;
/**
 * This function validates the inputs of a POST request on /institutions
 */
function validatePostInstitutionsInput(body) {
    if (!(0, basicValidation_1.validatePostInstitutionsRequestBody)(body)) {
        validatePostInstitutionsInput.errors = basicValidation_1.validatePostInstitutionsRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePostInstitutionsInput = validatePostInstitutionsInput;
/**
 * This function validates the outputs to a POST request on /institutions
 */
function validatePostInstitutionsOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!(0, basicValidation_1.validatePostInstitutionsResponse201)(response.body)) {
            validatePostInstitutionsOutput.errors = basicValidation_1.validatePostInstitutionsResponse201.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostInstitutionsOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostInstitutionsOutput = validatePostInstitutionsOutput;
/**
 * This function validates the inputs of a GET request on /institutions/{institution_id}
 */
function validateGetInstitutionsByInstitutionIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateInstitutionId)(parameters["institution_id"])) {
            validateGetInstitutionsByInstitutionIdInput.errors = basicValidation_1.validateInstitutionId.errors;
            return false;
        }
    }
    return true;
}
exports.validateGetInstitutionsByInstitutionIdInput = validateGetInstitutionsByInstitutionIdInput;
/**
 * This function validates the outputs to a GET request on /institutions/{institution_id}
 */
function validateGetInstitutionsByInstitutionIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetInstitutionsByInstitutionIdResponse200)(response.body)) {
            validateGetInstitutionsByInstitutionIdOutput.errors = basicValidation_1.validateGetInstitutionsByInstitutionIdResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetInstitutionsByInstitutionIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetInstitutionsByInstitutionIdOutput = validateGetInstitutionsByInstitutionIdOutput;
/**
 * This function validates the inputs of a PATCH request on /institutions/{institution_id}
 */
function validatePatchInstitutionsByInstitutionIdInput(parameters, body) {
    if (parameters) {
        if (!(0, basicValidation_1.validateInstitutionId)(parameters["institution_id"])) {
            validatePatchInstitutionsByInstitutionIdInput.errors = basicValidation_1.validateInstitutionId.errors;
            return false;
        }
    }
    if (body && !(0, basicValidation_1.validatePatchInstitutionsByInstitutionIdRequestBody)(body)) {
        validatePatchInstitutionsByInstitutionIdInput.errors = basicValidation_1.validatePatchInstitutionsByInstitutionIdRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePatchInstitutionsByInstitutionIdInput = validatePatchInstitutionsByInstitutionIdInput;
/**
 * This function validates the outputs to a PATCH request on /institutions/{institution_id}
 */
function validatePatchInstitutionsByInstitutionIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validatePatchInstitutionsByInstitutionIdResponse200)(response.body)) {
            validatePatchInstitutionsByInstitutionIdOutput.errors = basicValidation_1.validatePatchInstitutionsByInstitutionIdResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePatchInstitutionsByInstitutionIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePatchInstitutionsByInstitutionIdOutput = validatePatchInstitutionsByInstitutionIdOutput;
/**
 * This function validates the inputs of a DELETE request on /institutions/{institution_id}
 */
function validateDeleteInstitutionsByInstitutionIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateInstitutionId)(parameters["institution_id"])) {
            validateDeleteInstitutionsByInstitutionIdInput.errors = basicValidation_1.validateInstitutionId.errors;
            return false;
        }
    }
    return true;
}
exports.validateDeleteInstitutionsByInstitutionIdInput = validateDeleteInstitutionsByInstitutionIdInput;
/**
 * This function validates the outputs to a DELETE request on /institutions/{institution_id}
 */
function validateDeleteInstitutionsByInstitutionIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 204) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateDeleteInstitutionsByInstitutionIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateDeleteInstitutionsByInstitutionIdOutput = validateDeleteInstitutionsByInstitutionIdOutput;
/**
 * This function validates the inputs of a GET request on /proxy
 */
function validateGetProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validateGetProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validateGetProxyInput = validateGetProxyInput;
/**
 * This function validates the outputs to a GET request on /proxy
 */
function validateGetProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validateGetProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetProxyOutput = validateGetProxyOutput;
/**
 * This function validates the inputs of a POST request on /proxy
 */
function validatePostProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validatePostProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validatePostProxyInput = validatePostProxyInput;
/**
 * This function validates the outputs to a POST request on /proxy
 */
function validatePostProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validatePostProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostProxyOutput = validatePostProxyOutput;
/**
 * This function validates the inputs of a PUT request on /proxy
 */
function validatePutProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validatePutProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validatePutProxyInput = validatePutProxyInput;
/**
 * This function validates the outputs to a PUT request on /proxy
 */
function validatePutProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validatePutProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePutProxyOutput = validatePutProxyOutput;
/**
 * This function validates the inputs of a PATCH request on /proxy
 */
function validatePatchProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validatePatchProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validatePatchProxyInput = validatePatchProxyInput;
/**
 * This function validates the outputs to a PATCH request on /proxy
 */
function validatePatchProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validatePatchProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePatchProxyOutput = validatePatchProxyOutput;
/**
 * This function validates the inputs of a DELETE request on /proxy
 */
function validateDeleteProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validateDeleteProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validateDeleteProxyInput = validateDeleteProxyInput;
/**
 * This function validates the outputs to a DELETE request on /proxy
 */
function validateDeleteProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validateDeleteProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateDeleteProxyOutput = validateDeleteProxyOutput;
/**
 * This function validates the inputs of a HEAD request on /proxy
 */
function validateHeadProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validateHeadProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validateHeadProxyInput = validateHeadProxyInput;
/**
 * This function validates the outputs to a HEAD request on /proxy
 */
function validateHeadProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validateHeadProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateHeadProxyOutput = validateHeadProxyOutput;
/**
 * This function validates the inputs of a OPTIONS request on /proxy
 */
function validateOptionsProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validateOptionsProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validateOptionsProxyInput = validateOptionsProxyInput;
/**
 * This function validates the outputs to a OPTIONS request on /proxy
 */
function validateOptionsProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validateOptionsProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateOptionsProxyOutput = validateOptionsProxyOutput;
/**
 * This function validates the inputs of a TRACE request on /proxy
 */
function validateTraceProxyInput(parameters) {
    if (parameters) {
        if (parameters["URL"] && !(0, basicValidation_1.validateURL)(parameters["URL"])) {
            validateTraceProxyInput.errors = basicValidation_1.validateURL.errors;
            return false;
        }
    }
    return true;
}
exports.validateTraceProxyInput = validateTraceProxyInput;
/**
 * This function validates the outputs to a TRACE request on /proxy
 */
function validateTraceProxyOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status >= 100 && response.status < 200) {
        return true;
    }
    if (response.status >= 200 && response.status < 300) {
        return true;
    }
    if (response.status >= 300 && response.status < 400) {
        return true;
    }
    if (response.status >= 400 && response.status < 500) {
        return true;
    }
    if (response.status >= 500 && response.status < 600) {
        return true;
    }
    validateTraceProxyOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateTraceProxyOutput = validateTraceProxyOutput;
//# sourceMappingURL=requestValidation.js.map