"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const express_1 = __importDefault(require("express"));
const operations = __importStar(require("../operations"));
const types_1 = require("./types");
const requestValidation_1 = require("./requestValidation");
function routes(options = {
    security: {
        JWT: (_req, _scopes) => {
            throw new Error("JWT authentication not implemented");
        },
    },
}) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        let userData = {};
        for (const method in securityRequirement) {
            userData[method] = await options.security[method](request, securityRequirement[method]);
        }
        return userData;
    }
    router.get("/institutions", async (req, res, next) => {
        const security = [
            {
                JWT: ["institution", "institution:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetInstitutionsInput)()) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetInstitutionsInput.errors, 400);
            }
            const result = await operations.getInstitutions(userData);
            if (!(0, requestValidation_1.validateGetInstitutionsOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetInstitutionsOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/institutions", async (req, res, next) => {
        const security = [
            {
                JWT: ["institution", "institution:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostInstitutionsInput)(body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostInstitutionsInput.errors, 400);
            }
            const result = await operations.postInstitutions(body, userData);
            if (!(0, requestValidation_1.validatePostInstitutionsOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostInstitutionsOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/institutions/:institution_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["institution", "institution:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            institution_id: req.params["institution_id"],
        };
        try {
            if (!(0, requestValidation_1.validateGetInstitutionsByInstitutionIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetInstitutionsByInstitutionIdInput.errors, 400);
            }
            const result = await operations.getInstitutionsByInstitutionId(parameters, userData);
            if (!(0, requestValidation_1.validateGetInstitutionsByInstitutionIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetInstitutionsByInstitutionIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/institutions/:institution_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["institution", "institution:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            institution_id: req.params["institution_id"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchInstitutionsByInstitutionIdInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePatchInstitutionsByInstitutionIdInput.errors, 400);
            }
            const result = await operations.patchInstitutionsByInstitutionId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchInstitutionsByInstitutionIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePatchInstitutionsByInstitutionIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/institutions/:institution_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["institution", "institution:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            institution_id: req.params["institution_id"],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteInstitutionsByInstitutionIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeleteInstitutionsByInstitutionIdInput.errors, 400);
            }
            const result = await operations.deleteInstitutionsByInstitutionId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteInstitutionsByInstitutionIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeleteInstitutionsByInstitutionIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateGetProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetProxyInput.errors, 400);
            }
            const result = await operations.getProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validateGetProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostProxyInput.errors, 400);
            }
            const result = await operations.postProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.put("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePutProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePutProxyInput.errors, 400);
            }
            const result = await operations.putProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validatePutProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePutProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePatchProxyInput.errors, 400);
            }
            const result = await operations.patchProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePatchProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateDeleteProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeleteProxyInput.errors, 400);
            }
            const result = await operations.deleteProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validateDeleteProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeleteProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.head("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateHeadProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateHeadProxyInput.errors, 400);
            }
            const result = await operations.headProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validateHeadProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateHeadProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.options("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateOptionsProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateOptionsProxyInput.errors, 400);
            }
            const result = await operations.optionsProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validateOptionsProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateOptionsProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.trace("/proxy", async (req, res, next) => {
        const security = [
            {
                JWT: ["authorized_proxy"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            URL: req.query["URL"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validateTraceProxyInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateTraceProxyInput.errors, 400);
            }
            const result = await operations.traceProxy(parameters, body, userData);
            if (!(0, requestValidation_1.validateTraceProxyOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateTraceProxyOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map